﻿using System;
using System.Windows.Forms;
using ThinkGeo.MapSuite.Core;
using ThinkGeo.MapSuite.DesktopEdition;

namespace WinWms
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
             winformsMap1.MapUnit = GeographyUnit.Meter;
             winformsMap1.CurrentExtent = new RectangleShape(-20037508.23146975, 18418382.1370691, 20037508.23146975, -20037508.231469806);
            winformsMap1.BackgroundOverlay.BackgroundBrush = new GeoSolidBrush(GeoColor.GeographicColors.ShallowOcean);

            //WmsRasterLayer wmsImageLayer = new WmsRasterLayer(new Uri("http://howdoiwms.thinkgeo.com/WmsServer.aspx?"));
            //WmsRasterLayer wmsImageLayer = new WmsRasterLayer(new Uri("http://howdoiwms.thinkgeo.com/WmsServer.aspx?username=username&password=password"));
            WmsRasterLayer wmsImageLayer = new WmsRasterLayer(new Uri("http://howdoiwms.thinkgeo.com/WmsServer.aspx"));
            wmsImageLayer.SendingWebRequest += wmsImageLayer_SendingWebRequest;
            wmsImageLayer.UpperThreshold = double.MaxValue;
            wmsImageLayer.LowerThreshold = 0;
            wmsImageLayer.Parameters["userName"] = "userName";
            wmsImageLayer.Parameters.Add("password", "password");
           
            // Set the projection. The unit of projection 900913,3857 is meter.
            // See http://howdoiwms.thinkgeo.com/WmsServer.aspx?SERVICE=WMS&REQUEST=GetCapabilities to learn more wms server metadata description, the following parameters is setting
            // based on the metadata description.
            wmsImageLayer.Parameters["SRS"] = "EPSG:900913";
            wmsImageLayer.Open();
            foreach (string layerName in wmsImageLayer.GetServerLayerNames())
            {
                wmsImageLayer.ActiveLayerNames.Add(layerName);
            }
            wmsImageLayer.ActiveStyleNames.Add("Simple");

            // this parameter is just optional.
            wmsImageLayer.Exceptions = "application/vnd.ogc.se_xml";

            LayerOverlay imageOverlay = new LayerOverlay();
            imageOverlay.Layers.Add("wmsImageLayer", wmsImageLayer);
            winformsMap1.Overlays.Add(imageOverlay);

            wmsImageLayer.Close();

            winformsMap1.Refresh();
        }

        void wmsImageLayer_SendingWebRequest(object sender, SendingWebRequestEventArgs e)
        {
            string query = e.WebRequest.RequestUri.Query;
        }
    }
}
